//
// Generated by SwagGen
// https://github.com/yonaskolb/SwagGen
//

import Foundation
import JSONUtilities

extension API.ApiFoyer {

    /** Liste de tous les foyers présent dans un immeuble */
    public enum GetApiFoyerGetFoyers {

        public static let service = APIService<Response>(id: "getApiFoyerGetFoyers", tag: "Api Foyer", method: "GET", path: "/apiFoyer/getFoyers", hasBody: false)

        public final class Request: APIRequest<Response> {

            public struct Options {

                public var idImmeuble: String

                public init(idImmeuble: String) {
                    self.idImmeuble = idImmeuble
                }
            }

            public var options: Options

            public init(options: Options) {
                self.options = options
                super.init(service: GetApiFoyerGetFoyers.service)
            }

            /// convenience initialiser so an Option doesn't have to be created
            public convenience init(idImmeuble: String) {
                let options = Options(idImmeuble: idImmeuble)
                self.init(options: options)
            }

            public override var parameters: [String: Any] {
                var params: JSONDictionary = [:]
                params["idImmeuble"] = options.idImmeuble
                return params
            }
        }

        public enum Response: APIResponseValue, CustomStringConvertible, CustomDebugStringConvertible {
            public typealias SuccessType = [GetFoyerResponse]

            /** Succes */
            case status200([GetFoyerResponse])

            public var success: [GetFoyerResponse]? {
                switch self {
                case .status200(let response): return response
                }
            }

            public var response: Any {
                switch self {
                case .status200(let response): return response
                }
            }

            public var statusCode: Int {
                switch self {
                case .status200: return 200
                }
            }

            public var successful: Bool {
                switch self {
                case .status200: return true
                }
            }

            public init(statusCode: Int, data: Data) throws {
                switch statusCode {
                case 200: self = try .status200(JSONDecoder.decode(data: data))
                default: throw APIError.unexpectedStatusCode(statusCode: statusCode, data: data)
                }
            }

            public var description: String {
                return "\(statusCode) \(successful ? "success" : "failure")"
            }

            public var debugDescription: String {
                var string = description
                let responseString = "\(response)"
                if responseString != "()" {
                    string += "\n\(responseString)"
                }
                return string
            }
        }
    }
}
